Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class XPathContextMajor

    java.lang.Object
      net.sf.saxon.expr.XPathContextMinor
          net.sf.saxon.expr.XPathContextMajor

All Implemented Interfaces:
  XPathContext

    public class XPathContextMajor

extends XPathContextMinor

This class represents a "major context" in which an XPath expression is evaluated: a "major context" object allows all aspects of the dynamic context to change, whereas a "minor context" only allows changes to the focus and the destination for push output.

Constructor Summary
`XPathContextMajor(Controller c)` Constructor should only be called by the Controller, which acts as a XPathContext factory.
`XPathContextMajor(Item item, Configuration config)` Constructor for use in free-standing Java applications.
`XPathContextMajor(Item item, Executable exec)` Constructor for use in free-standing Java applications.

Method Summary
`GroupIterator` | `getCurrentGroupIterator()` Get the current group iterator.
`Mode` | `getCurrentMode()` Get the current mode.
`RegexIterator` | `getCurrentRegexIterator()` Get the current regex iterator.
`Rule` | `getCurrentTemplateRule()` Get the current template.
`ParameterSet` | `getLocalParameters()` Get the local parameters for the current template call.
`UserFunction` | `getTailCallFunction()` Determine whether the body of a function is to be repeated, due to tail-recursive function calls
`ParameterSet` | `getTunnelParameters()` Get the tunnel parameters for the current template call.
`net.sf.saxon.expr.XPathContextMajor.XSLTContext` | `getXSLTContext()` Get the XSLT-specific part of the context
`XPathContextMajor` | `newContext()` Construct a new context as a copy of another.
`static XPathContextMajor` | `newContext(XPathContextMinor p)`
`void` | `openStackFrame(int numberOfVariables)` Create a new stack frame large enough to hold a given number of local variables, for which no stack frame map is available.
`void` | `openStackFrame(SlotManager map)` Create a new stack frame for local variables, using the supplied SlotManager to define the allocation of slots to individual variables
`void` | `requestTailCall(UserFunction fn, ValueRepresentation[] variables)` Reset the local stack frame.
`void` | `resetStackFrameMap(SlotManager map, int numberOfParams)` Reset the stack frame variable map, while reusing the StackFrame object itself.
`void` | `setCurrentGroupIterator(GroupIterator collection)` Set the current grouping iterator.
`void` | `setCurrentMode(Mode mode)` Set the current mode.
`void` | `setCurrentRegexIterator(RegexIterator currentJRegexIterator)` Set the current regex iterator.
`void` | `setCurrentTemplateRule(Rule rule)` Set the current template.
`void` | `setLocalParameters(ParameterSet localParameters)` Set the local parameters for the current template call.
`void` | `setOrigin(InstructionInfoProvider expr)` Set the creating expression (for use in diagnostics).
`void` | `setStackFrame(SlotManager map, ValueRepresentation[] variables)` Set the local stack frame.
`void` | `setTunnelParameters(ParameterSet tunnelParameters)` Set the tunnel parameters for the current template call.
`boolean` | `useLocalParameter(int fingerprint, LocalParam binding, boolean isTunnel)` Use local parameter.

Methods inherited from class net.sf.saxon.expr.XPathContextMinor
`changeOutputDestination, evaluateLocalVariable, getCaller, getCollation, getConfiguration, getContextItem, getContextPosition, getController, getCurrentIterator, getDefaultCollation, getImplicitTimezone, getLast, getNameChecker, getNamePool, getOrigin, getOriginatingConstructType, getReceiver, getStackFrame, isAtLast, newCleanContext, newMinorContext, setCaller, setCurrentIterator, setLocalVariable, setOriginatingConstructType, setReceiver, setTemporaryReceiver`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XPathContextMajor

    public XPathContextMajor(Controller c)

  Constructor should only be called by the Controller, which acts as a XPathContext factory.

### XPathContextMajor

    public XPathContextMajor(Item item,
                             Executable exec)

  Constructor for use in free-standing Java applications.

  Parameters:
    `item` - the item to use as the initial context item. If this is null, the comtext item is initially undefined (which will cause a dynamic error if it is referenced).

### XPathContextMajor

    public XPathContextMajor(Item item,
                             Configuration config)

  Constructor for use in free-standing Java applications.

  Parameters:
    `item` - the item to use as the initial context item. If this is null, the comtext item is initially undefined (which will cause a dynamic error if it is referenced).

Method Detail

### newContext

    public XPathContextMajor newContext()

  Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context

  Specified by:
    `newContext` in interface `XPathContext`
  Overrides:
    `newContext` in class `XPathContextMinor`

### newContext

    public static XPathContextMajor newContext(XPathContextMinor p)

### getXSLTContext

    public net.sf.saxon.expr.XPathContextMajor.XSLTContext getXSLTContext()

  Get the XSLT-specific part of the context

  Specified by:
    `getXSLTContext` in interface `XPathContext`
  Overrides:
    `getXSLTContext` in class `XPathContextMinor`

### getLocalParameters

    public ParameterSet getLocalParameters()

  Get the local parameters for the current template call.

  Specified by:
    `getLocalParameters` in interface `XPathContext`
  Overrides:
    `getLocalParameters` in class `XPathContextMinor`
  Returns:
    the supplied parameters

### setLocalParameters

    public void setLocalParameters(ParameterSet localParameters)

  Set the local parameters for the current template call.

  Parameters:
    `localParameters` - the supplied parameters

### getTunnelParameters

    public ParameterSet getTunnelParameters()

  Get the tunnel parameters for the current template call.

  Specified by:
    `getTunnelParameters` in interface `XPathContext`
  Overrides:
    `getTunnelParameters` in class `XPathContextMinor`
  Returns:
    the supplied tunnel parameters

### setTunnelParameters

    public void setTunnelParameters(ParameterSet tunnelParameters)

  Set the tunnel parameters for the current template call.

  Parameters:
    `tunnelParameters` - the supplied tunnel parameters

### setOrigin

    public void setOrigin(InstructionInfoProvider expr)

  Set the creating expression (for use in diagnostics). The origin is generally set to "this" by the object that creates the new context. It's up to the debugger to determine whether this information is useful. The object will either be an `InstructionInfoProvider`, allowing information about the calling instruction to be obtained, or null.

  Specified by:
    `setOrigin` in interface `XPathContext`
  Overrides:
    `setOrigin` in class `XPathContextMinor`

### setStackFrame

    public void setStackFrame(SlotManager map,
                              ValueRepresentation[] variables)

  Set the local stack frame. This method is used when creating a Closure to support delayed evaluation of expressions. The "stack frame" is actually on the Java heap, which means it can survive function returns and the like.

### resetStackFrameMap

    public void resetStackFrameMap(SlotManager map,
                                   int numberOfParams)

  Reset the stack frame variable map, while reusing the StackFrame object itself. This is done on a tail call to a different function

### requestTailCall

    public void requestTailCall(UserFunction fn,
                                ValueRepresentation[] variables)

  Reset the local stack frame. This method is used when processing a tail-recursive function. Instead of the function being called recursively, the parameters are set to new values and the function body is evaluated repeatedly

### getTailCallFunction

    public UserFunction getTailCallFunction()

  Determine whether the body of a function is to be repeated, due to tail-recursive function calls

### openStackFrame

    public void openStackFrame(SlotManager map)

  Create a new stack frame for local variables, using the supplied SlotManager to define the allocation of slots to individual variables

  Parameters:
    `map` - the SlotManager for the new stack frame

### openStackFrame

    public void openStackFrame(int numberOfVariables)

  Create a new stack frame large enough to hold a given number of local variables, for which no stack frame map is available. This is used in particular when evaluating match patterns of template rules.

  Parameters:
    `numberOfVariables` - The number of local variables to be accommodated.

### setCurrentMode

    public void setCurrentMode(Mode mode)

  Set the current mode.

  Parameters:
    `mode` - the new current mode

### getCurrentMode

    public Mode getCurrentMode()

  Get the current mode.

  Specified by:
    `getCurrentMode` in interface `XPathContext`
  Overrides:
    `getCurrentMode` in class `XPathContextMinor`
  Returns:
    the current mode. May return null if the current mode is the default mode.

### setCurrentTemplateRule

    public void setCurrentTemplateRule(Rule rule)

  Set the current template. This is used to support xsl:apply-imports. The caller is responsible for remembering the previous current template and resetting it after use.

  Parameters:
    `rule` - the current template rule

### getCurrentTemplateRule

    public Rule getCurrentTemplateRule()

  Get the current template. This is used to support xsl:apply-imports

  Specified by:
    `getCurrentTemplateRule` in interface `XPathContext`
  Overrides:
    `getCurrentTemplateRule` in class `XPathContextMinor`
  Returns:
    the current template

### setCurrentGroupIterator

    public void setCurrentGroupIterator(GroupIterator collection)

  Set the current grouping iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0

  Parameters:
    `collection` - the new current GroupIterator

### getCurrentGroupIterator

    public GroupIterator getCurrentGroupIterator()

  Get the current group iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0

  Specified by:
    `getCurrentGroupIterator` in interface `XPathContext`
  Overrides:
    `getCurrentGroupIterator` in class `XPathContextMinor`
  Returns:
    the current grouped collection

### setCurrentRegexIterator

    public void setCurrentRegexIterator(RegexIterator currentJRegexIterator)

  Set the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.

  Parameters:
    `currentJRegexIterator` - the current regex iterator

### getCurrentRegexIterator

    public RegexIterator getCurrentRegexIterator()

  Get the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.

  Specified by:
    `getCurrentRegexIterator` in interface `XPathContext`
  Overrides:
    `getCurrentRegexIterator` in class `XPathContextMinor`
  Returns:
    the current regular expressions iterator

### useLocalParameter

    public boolean useLocalParameter(int fingerprint,
                                     LocalParam binding,
                                     boolean isTunnel)
                              throws XPathException

  Use local parameter. This is called when a local xsl:param element is processed. If a parameter of the relevant name was supplied, it is bound to the xsl:param element. Otherwise the method returns false, so the xsl:param default will be evaluated

  Specified by:
    `useLocalParameter` in interface `XPathContext`
  Overrides:
    `useLocalParameter` in class `XPathContextMinor`
  Parameters:
    `fingerprint` - The fingerprint of the parameter name
    `binding` - The XSLParam element to bind its value to
    `isTunnel` - True if a tunnel parameter is required, else false
  Returns:
    true if a parameter of this name was supplied, false if not
  Throws:
    `XPathException`

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.